package ru.ulstu.extractor.gitrepository.model;

import ru.ulstu.extractor.core.BaseEntity;
import ru.ulstu.extractor.util.StringUtils;

import javax.persistence.Entity;

@Entity
public class GitRepository extends BaseEntity {
    private String url;
    private String repositoryId;

    public GitRepository() {
    }

    public GitRepository(String repositoryUrl, String repositoryId) {
        this.url = repositoryUrl;
        this.repositoryId = repositoryId;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getRepositoryId() {
        return repositoryId;
    }

    public String getName() {
        int lastDelimiterIndex = url.lastIndexOf("/");
        return StringUtils.removeDotGit((lastDelimiterIndex > 0 && lastDelimiterIndex < url.length())
                ? url.substring(lastDelimiterIndex + 1)
                : url);
    }
}
