package ru.ulstu.extractor.ts.creator.scheduled;

import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;
import ru.ulstu.extractor.branch.model.Branch;
import ru.ulstu.extractor.gitrepository.service.GitRepositoryService;
import ru.ulstu.extractor.ts.model.TimeSeriesType;
import ru.ulstu.extractor.ts.model.TimeSeriesValue;
import ru.ulstu.extractor.ts.service.TimeSeriesService;

@Component
public class BranchTS extends ScheduledTimeSeriesCreator {
    private final TimeSeriesService timeSeriesService;
    private final GitRepositoryService gitRepositoryService;
    private final ApplicationContext applicationContext;

    public BranchTS(TimeSeriesService timeSeriesService,
                    GitRepositoryService gitRepositoryService,
                    ApplicationContext applicationContext) {
        this.timeSeriesService = timeSeriesService;
        this.gitRepositoryService = gitRepositoryService;
        this.applicationContext = applicationContext;
    }

    @Override
    public TimeSeriesType getTimeSeriesType() {
        return TimeSeriesType.BRANCHES;
    }

    @Override
    public TimeSeriesService getTimeSeriesService() {
        return timeSeriesService;
    }

    @Override
    public GitRepositoryService getGitRepositoryService() {
        return gitRepositoryService;
    }

    @Override
    public TimeSeriesValue getNewTimeSeriesValue(Branch branch) {
        return new TimeSeriesValue(applicationContext.getBean(getGitRepositoryService().getGitApiServiceClass(branch))
                .getBranchesCount(branch));
    }
}
